
(function () {
	'use strict';

	var cssMinValue = function (options) {
		this.init(options);
	};

	cssMinValue.VERSION = '1.0.0';
	cssMinValue.DEFAULTS = {
		showDebug : false,
		confirmTemplate: '\
  				<div class="modal fade" id="confirmation_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<form role="form" method="post" action="category_delete" id="delete_data">\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-danger confirmYes" >Ja ich m&ouml;chte</button>\
			    					<button type="button" class="btn btn-primary" data-dismiss="modal">Nein ich m&ouml;chte nicht</button>\
			    				</div>\
			    			</form>\
			    		</div>\
			    	</div>\
			    </div>\
			',
		noticeTemplate: '\
  				<div class="modal fade " id="css_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<!-- <form role="form" method="post" action="" >\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-default" data-dismiss="modal">schlie&szlig;en</button>\
			    				</div>\
			    			</form>-->\
			    		</div>\
			    	</div>\
			    </div>\
			'
	};
	cssMinValue.prototype = {

		constructor: cssMinValue,

		init: function (options) {
			this.options = $.extend({}, cssMinValue.DEFAULTS, options);
			var that = this;
		},

		register: function(options) {
			var that=this;
			this.debug("function register started");
			that.checkTrashButtonStatus();

			$(document).on("click",".iso-group .css-plus", function(e) {
				e.stopPropagation();
				var el = $(this).closest(".input-group").last().clone();
				$(el).find("input").val("");
				$(el).find("select").val("");
				$(this).closest("fieldset").append(el);
				that.checkTrashButtonStatus();
			});

			$(document).on("click",".iso-group .css-minus", function(e) {
				e.stopPropagation();
				$(this).closest(".iso-group").remove();
				that.checkTrashButtonStatus();
			});
		},



		openModalConfirmation: function (el, selector, titel,content) {
			$("#confirmation_modal").remove();
			$("body").append(this.options.confirmTemplate);
			$("#confirmation_modal .modal-content").addClass(selector);
			$("#confirmation_modal .modal-title").html(titel);
			$("#confirmation_modal .modal-body").html(content);
			$("#confirmation_modal .confirmYes").on("click", function() {
				$(el).addClass("confirmed").trigger("click");
				$("#confirmation_modal").modal("hide");
			});
			$("#confirmation_modal").modal("show");
		},




		checkTrashButtonStatus : function() {
			$("fieldset.css-min-value").each(function() {
				if($(this).find(".input-group").length<2) {
					$(this).find(".css-minus").attr("disabled",true);
				} else {
					$(this).find(".css-minus").attr("disabled",false);
				}
			});
		},

		debug: function(s) {
			if(this.options.showDebug) {
				console.log(s);
			}
		},

		openModalNotice: function (el, selector, titel,content) {
			$("#css_modal").remove();
			$("body").append(this.options.noticeTemplate);
			if(selector) $("#css_modal .modal-content").addClass(selector);
			$("#css_modal .modal-title").html(titel);
			$("#css_modal .modal-body").html(content);
			$("#css_modal").modal("show");
		},

		post_data: function (url, data) {
			jQuery.ajax({
				type: 'POST',
				url: url,
				data: data,
				showNoSuggestionNotice: true,
				dataType: 'json',
				beforeSend: function(jqXHR) {
					jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
				},
				success: function(data,responseText,jqXHR) {
					if( jqXHR.status == 204 ) {
						$.cssVouch.debug('sorry, here is nothing to do for me. (Token problem?)')
						return false;
					}
					if( jqXHR.status == 404 ) {
						$.cssVouch.debug('sorry, here is nothing to show you.')
						return false;
					}
					if( jqXHR.status == 403 ) {
						$.cssVouch.debug('sorry, this is no place for you.')
						return false;
					}
					//debug(data);
					if( data.script )	{
						eval(data.script);
					}
					$("body").trigger('contentChanged');
				},
				error: function() {
					this.debug('something is wrong....anything buggy?');
				},
				complete: function() {

				}
			});
		},
	};

	$.cssMinValue = function(options) {
		$.cssMV = new cssMinValue(options);
		$.cssMV.register();
		return $.cssMV;
	};
})(jQuery);

$(function() {
	$.cssMinValue({});
});


